#include "stdafx.h"
#include "TetrisAI.h"
#include "debug.h"

static int x;
static int rotate;
//Returns 1 on Success
int initAI(){
	init_debug();
	dprintf("AI Initialized\n");
	return 1;
}

int cleanUpAI(){
	stop_debug();
	return 1;
}

int makeMoveAI(PIECE *current){
//	dprintf("\nmakeMoveAI Begining\n",x);
	int tx,i,j,hit=0;

	if (rotate){
		rotate--;
		return AI_ROTATE;
	}
	/*** Detimaning if need to move left or right ********************/
	for (i=0;i<4;i++){
		for (j=0; j<4; j++){
			if(current->piece[i][j]!=0){
				hit=1;
				break;
			}
		}
		if (hit){
			tx = current->x + i;
			break;
		}
	}
	
	if(tx > x){
//		dprintf("AI Move = AI_LEFT\n");
		return AI_LEFT;
	}
	else if (tx < x){
//		dprintf("AI Move = AI_RIGHT\n");
		return AI_RIGHT;

	}

	/*** No shift or rotation is need ********************************/
//	dprintf("AI Move = AI_NO_MOVE\n");
	return AI_NO_MOVE;
}

void thinkAI(int tboard[10][22], PIECE *tcurrent) {
	int x2,y,i,change_all=0,loop=1,line=0,crotate=0;
	int hit,j,t,q=0,score=0,a=10000;
	int oldscore=0;
	int wLow,wHigh;
	int temp;
	int board[10][22];
	PIECE current;
	dprintf("started AI\n");
	rotate = 0;
	/*** The AI will start be getting some basic info **********/
	current.x = tcurrent->x;
	current.y = tcurrent->y;
	current.type = tcurrent->type;
	for(x2=0;x2<4;x2++)
		for(y=0;y<4;y++)
			current.piece[x2][y] = tcurrent->piece[x2][y];

	/*** Checking all piece placment spots ***********************/
	//will need to run threw all Rotations
	for(q=0;q<4;q++){
		hit=0;
		for(i=0;i<4;i++){
			for(j=0;j<4;j++){
				if(current.piece[i][j]!=0){
					hit = 1;
					break;
				}
			}
			if(hit){
				wLow = i;
				break;
			}
		}
		hit=0;
		for(i=3;i>=0;i--){
			for(j=0;j<4;j++){
				if(current.piece[i][j]!=0){
					hit = 1;
					break;
				}
			}
			if(hit){
				wHigh = i;
				break;
			}
		}
		temp = 10 - wHigh;
		for(i=0-wLow;i<temp;i++){
			//Copies origanl board
			boardcpy(board,tboard);
			change_all=0;
			loop=1;
			line=0;
			t=0;

			//looping untill piece hits bottem of other blocks
			while(!change_all){
				for (x2=0;x2<4;x2++)
					for (y=0;y<4;y++)
						if((current.piece[x2][y]!=0)&&(current.y+y+t==21))
							change_all=1;
				if (change_all!=1)
					for (x2=0;x2<4;x2++)
						for (y=0;y<4;y++)
							if ((x2+i<10)&&(current.y+y+1+t<22)&&(current.piece[x2][y]!=0))
								if (board[x2+i][y+current.y+1+t]!=0)
									change_all=1;
				if(change_all==0)
					t++;
			}
			for (x2=0;x2<4;x2++)
				for (y=0;y<4;y++)
					if ((x2+i<10)&&(current.y+t+y>=0)&&(current.piece[x2][y]!=0))
						board[x2+i][y+current.y+t]=current.piece[x2][y];
			y=21;
			//Removes Lines
			while(loop){
				if ((board[0][y]!=0)&&(board[1][y]!=0)&&(board[2][y]!=0)&&(board[3][y]!=0))
					if ((board[4][y]!=0)&&(board[5][y]!=0)&&(board[6][y]!=0)&&(board[7][y]!=0))
						if ((board[8][y]!=0)&&(board[9][y]!=0)){
							for (x2=0;x2<10;x2++)
								for (j=y-1;j>0;j--){
									board[x2][j+1]=board[x2][j];
									board[x2][j]=0;
								}
								y++;
								line++;
						}
				y--;
				if (y==0)
					loop=0;
			}
			score = numOfHoles(board) - line*2 - t;
			//dprintf("\nNumber of Holes = %d\n",numOfHoles(board));
			if (score < a){
				x = i +wLow;
				rotate = crotate;
				a = score;
			}
		
		}
		crotate++;
		RotateAI(&current);
	}

	/*** Finnal desidion made ************************************/
	dprintf("thinkAI x = %d, wLow = %d, wHigh = %d, temp = %d\n",x,wLow,wHigh,temp);
}



int numOfHoles(int board[10][22]){
	int r=0;
	int i,j,active;
	for (i=0;i<10;i++){
		active = 0;
		for (j=0;j<22;j++){
			if (!active){
				if(board[i][j]!=0)
					active = 1;
			}
			else{
				if(board[i][j]==0)
					r++;
			}
		}
	}
	return r;
}

int minofpos(int a,int b,int c,int d){
	int temp;

	if (a < b)
		temp = a;
	else
		temp = b;

	if (c < temp)
		temp = c;

	if (d < temp)
		temp = d;

	return temp;
}

void boardcpy(int dboard[10][22],int sboard[10][22]){
	int i,j;
	for (i=0;i<10;i++){
		for (j=0;j<22;j++){
			 dboard[i][j] = sboard[i][j];
		}
	}
}


void RotateAI(PIECE *current)
{
	int x,y,dir=1,can_rotate=1;
	char temp [4][4];

	for(x=0;x<4;x++)
		for(y=0;y<4;y++)
			temp[x][y] = 0;

	switch(current->type) {
		case 1:
			if (dir==1) {
				for(x=0;x<4;x++)
					for(y=0;y<4;y++)
						temp[y][3-x] = current->piece[x][y];
			}
			else if (dir==2) {
				for(x=0;x<4;x++)
					for(y=0;y<4;y++)
						temp[3-y][x] = current->piece[x][y];
			}
			break;
		case 2:
			if (dir==1) {
				for(x=1;x<4;x++)
					for(y=0;y<3;y++)
						temp[y+1][3-x] = current->piece[x][y];
			}
			else if (dir==2) {
				for(x=1;x<4;x++)
					for(y=0;y<3;y++)
						temp[3-y][x-1] = current->piece[x][y];
			}
			break;
		case 3:
			for(x=0;x<4;x++)
				for(y=0;y<4;y++)
					temp[x][y] = current->piece[x][y];
			can_rotate=0;
			break;
	}

	for(x=0;x<4;x++)
		for(y=0;y<4;y++)
			current->piece[x][y] = temp[x][y];

}